<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2009 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_3/pages/lottery.php $
 * $Id: lottery.php 1692 2009-11-01 20:48:01Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

$title = 'LOTTERY_TITLE';

page_header();

if (ROUND_FINISHED)
	unavailable(lang('LOTTERY_UNAVAILABLE_END'));
if (!ROUND_STARTED)
	unavailable(lang('LOTTERY_UNAVAILABLE_START'));

$tickcost = round($emp1->e_networth / log($emp1->e_networth, 25));

if ($action == 'ticket') do
{
	$tickcount = $db->queryCell('SELECT COUNT(*) FROM '. LOTTERY_TABLE .' WHERE e_id = ?', array($emp1->e_id));
	if ($tickcount >= LOTTERY_MAXTICKETS)
	{
		notice(lang('LOTTERY_TOO_MANY_TICKETS'));
		break;
	}
	if ($emp1->e_cash < $tickcost)
	{
		notice(lang('LOTTERY_NOT_ENOUGH_MONEY'));
		break;
	}

	$maxnum = $db->queryCell('SELECT MAX(e_id) FROM '. EMPIRE_TABLE);
	do
	{
		$ticknum = mt_rand(1, LOTTERY_MAXTICKETS * $maxnum);
	} while ($db->queryCell('SELECT COUNT(*) FROM '. LOTTERY_TABLE .' WHERE l_ticket = ? AND e_id > 0', array($ticknum)) > 0);

	$q = $db->prepare('INSERT INTO '. LOTTERY_TABLE .' (e_id,l_ticket,l_cash) VALUES (?,?,?)');
	$q->bindIntValue(1, $emp1->e_id);
	$q->bindIntValue(2, $ticknum);
	$q->bindIntValue(3, $tickcost);
	$q->execute() or warning('Failed to add lottery ticket', 0);

	$emp1->e_cash -= $tickcost;
	$world->adjust('lotto_current_jackpot', $tickcost);

	notice(lang('LOTTERY_COMPLETE', prenum($ticknum), money($tickcost)));
	logevent(varlist(array('tickcost'), get_defined_vars()));

	// recalculate networth now, and display next ticket price
	$emp1->updateNet();
	$tickcost = round($emp1->e_networth / log($emp1->e_networth, 25));
} while (0);
notices();
$q = $db->prepare('SELECT * FROM '. LOTTERY_TABLE .' WHERE e_id = ?');
$q->bindIntValue(1, $emp1->e_id);
$q->execute() or warning('Failed to fetch lottery tickets', 0);
$tickets = $q->fetchAll();
$totaltickets = $db->queryCell('SELECT COUNT(*) FROM '. LOTTERY_TABLE .' WHERE e_id != 0');
?>
<?=lang('LOTTERY_DESC')?><br />
<?=lang('LOTTERY_NEXTTICKET', money($tickcost))?><br />
<?=lang('LOTTERY_MAXALLOWED', plural(LOTTERY_MAXTICKETS, 'TICKETS_SINGLE', 'TICKETS_PLURAL'))?><br /><br />
<b><?=lang('LOTTERY_CURJACKPOT')?></b> <?=money($world->lotto_current_jackpot)?><br /><br />
<?=lang('LOTTERY_TOTALBOUGHT')?> <span class="cneutral"><?=$totaltickets?></span><br />
<?
if ($world->lotto_last_winner)
{
	$emp_a = new prom_empire($world->lotto_last_winner);
	$emp_a->loadPartial();
	echo lang('LOTTERY_LAST_WINNER', prenum($world->lotto_last_picked), $emp_a, money($world->lotto_yesterday_jackpot));
}
else	echo lang('LOTTERY_LAST_NOWINNER', prenum($world->lotto_last_picked), money($world->lotto_jackpot_increase));
echo "<br />\n";
if (count($tickets))
{
	$ticklist = '';
	foreach ($tickets as $ticket)
	{
		if (strlen($ticklist))
			$ticklist .= lang('LOTTERY_TICKET_LISTSEP');
		$ticklist .= prenum($ticket['l_ticket']);
	}
	echo lang('LOTTERY_HAVE_TICKETS', $ticklist);
}
else	echo lang('LOTTERY_HAVE_NO_TICKETS');
echo "<br />\n";

if ($emp1->e_cash < $tickcost)
	echo lang('LOTTERY_CANT_AFFORD') ."<br />\n";
elseif (count($tickets) < LOTTERY_MAXTICKETS)
{
?>
<form method="post" action="?location=lottery">
<div>
<input type="hidden" name="action" value="ticket" />
<input type="submit" value="<?=lang('LOTTERY_SUBMIT')?>" />
</div>
</form>
<?
}
page_footer();
?>
